<template>
    <div>
      <input type="text" v-model="value" @input="handleInput" @blur="handleBlur">
    </div>
</template>

<script>
export default {
  name: 'x-input',
  data() {
    return {
        value: '',
        rawValue: 0, // 存储原始数值，不带单位
        unit: '' // 存储单位，如'm', 'k'等
    };
  },
  computed: {
    // formattedValue: {
    //   get() {
    //     return this.formatValue(this.rawValue);
    //   },
    //   set(value) {
    //     this.parseValue(value);
    //   }
    // }
  },
  mounted() {
  },
  methods: {
    formatValue(value) {
      return (value / Math.pow(10, this.unitMultiplier)).toString().replace(/\B(?=(\d{3})+(?!\d))/g, ",");
    },
    parseValue(value) {
      const match = value.match(/([0-9,.]+)([a-zA-Z]?)/);
      if (match) {
        this.rawValue = parseFloat(match[1].replace(/,/g, ''));
        this.unit = match[2]; // 获取单位，如果有的话
      } else {
        this.rawValue = 0;
        this.unit = '';
      }
    },
    handleInput(event) {
        // 定义正则表达式，允许数字和指定的字母（例如'A', 'B', 'C'）
        const regex = /^[0-9bkmBKM]*$/;
        const input = event.target.value;
        this.value = event.target.value.replace(!regex, '')
        // 如果输入不符合正则表达式，则截取掉不符合的部分
        // if (regex.test(input)) {
        //     this.value = input.substring(0, input.length - 1); // 去掉最后一个字符
        // } else {
        //     this.value = input; // 符合正则表达式，更新输入值
        // }
    },
    handleBlur () {
        // if (this.value)
    }
  }
};
</script>

<style lang="scss" scoped>
</style>